#!/usr/bin/env python

'''
Server mode using Gevent, using tunnelling feature to give a remote shell.
'''

from __future__ import absolute_import

import sys
import logging

from sjrpc.server import RpcServer
from sjrpc.utils import RpcHandler, pass_connection
from sjrpc.core.protocols import VpnProtocol

logger = logging.getLogger()
logger.setLevel(logging.DEBUG)
fmt = logging.Formatter('%(levelname)s %(name)s %(message)s')
handler = logging.StreamHandler()
handler.setFormatter(fmt)
logger.addHandler(handler)


class VpnHandler(RpcHandler):

    @pass_connection
    def launch_vpn(self, connection, name='vpns'):
        connection.register_protocol(1, VpnProtocol, tun_prefix=name)
        return 1

# Get arguments from the command line:
if len(sys.argv) < 3:
    print 'Usage: %s <listening address> <listening port>' % sys.argv[0]
    sys.exit(2)
address = sys.argv[1]
port = int(sys.argv[2])

# Create the server instance:
import pyev
loop = pyev.default_loop(flags=~ pyev.EVBACKEND_EPOLL)
rpcserver = RpcServer.from_addr(address, port, loop=loop, conn_kw=dict(handler=VpnHandler()))
rpcserver.run()

